## kubernetes 1.0

=== debian/changelog ===
kubernetes (1.0) cosmic; urgency=medium

  * Initial Packaging Release. (LP: #1780334)

 -- Adam Stokes <adam.stokes@ubuntu.com>  Mon, 27 Aug 2018 09:31:00 -0400
