=== debian/control ===
Source: kubernetes
Section: misc
Priority: optional
Maintainer: Adam Stokes <adam.stokes@ubuntu.com>
Build-Depends: debhelper (>=11)
Standards-Version: 4.1.4
Homepage: https://k8s.io

Package: kubernetes
Architecture: all
Depends: ${misc:Depends}
Description: Installer package for Kubernetes
 Kubernetes is an open-source system for automating deployment, scaling, and
 management of containerized applications.
