## kubernetes 1.5.5+dfsg

=== debian/changelog ===
kubernetes (1.5.5+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Don't build on ppc64le due to Go linker problems. See GitHub issue
    https://github.com/golang/go/issues/15823.
  * Don't build on ppc64 as it's not supported by upstream at the
    moment. (Closes: #860505)

 -- Tim Potter <tpot@hpe.com>  Sat, 03 Jun 2017 08:00:51 +1000

kubernetes (1.5.5+dfsg-1) unstable; urgency=low

  [ Dmitry Smirnov ]
  * Switch to bundled "rkt".
  * rules: remove "-p" option from build and test overrides.
  * control: drop obsolete "golang-clockwork-dev" alternative.
  * New patch to disable test failing on [armel].
  * Upload to unstable.

  [ Tim Potter ]
  * New upstream version. [March 2017]
  * Big updates to d/rules and d/copyright to update to upstream
    changes made since the 1.2.x release.
  * Refresh patches to bring up to date with upstream changes since
    1.2.x.
  * control: add lsb-base as dependency for sysvinit scripts.
  * Suppress spelling-error-in-binary Lintian messages.

 -- Tim Potter <tpot@hpe.com>  Thu, 13 Apr 2017 16:45:57 +1000

kubernetes (1.2.5+dfsg-1) experimental; urgency=medium

  * New upstream release [June 2016].
  * Switch to private "github.com/golang/glog" due to log noise.
  * Disabled failing tests; no longer ignore failures in tests.
  * Build/test using 2 cores only.
  * New patch to update appc/cni name space (fixes FTBFS).
  * Removed obsolete "spf13-cobra.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 03 Jul 2016 04:12:28 +1000

kubernetes (1.2.4+dfsg-2) experimental; urgency=medium

  * Added new patch to fix incompatibility with "imdario/mergo" v0.2.2
    (Closes: #825753).
    Thanks, Florian Ernst.
  * Enable tests but ignore failures for now.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 17 Jun 2016 01:41:38 +1000

kubernetes (1.2.4+dfsg-1) experimental; urgency=medium

  * New upstream release [May 2016].
  * New patch to print output of "uname -m" on unsupported architectures.
  * New "docker.patch" to fix potential FTBFS.
    + Build-Depends += "golang-github-docker-distribution-dev".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 15 Jun 2016 21:03:01 +1000

kubernetes (1.2.3+dfsg-1) experimental; urgency=low

  * Initial release (Closes: #795652).

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 25 Apr 2016 22:40:12 +1000
