=== debian/control ===
Source: kubernetes
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper (>=9), bash-completion, dh-golang, dh-systemd
        ,golang-go
        ,go-bindata (>= 3.0.7~)
        ,go-md2man (>= 1.0.1~)
	,libseccomp-dev
	,golang-github-spf13-pflag-dev
	,golang-github-spf13-viper-dev
	,golang-github-spf13-cast-dev
	,golang-github-spf13-cobra-dev
	,golang-github-spf13-afero-dev
	,golang-github-spf13-jwalterweatherman-dev
	,golang-github-davecgh-go-spew-dev
	,golang-github-blang-semver-dev
	,golang-github-go-openapi-spec-dev
	,golang-github-go-openapi-swag-dev
	,golang-github-go-openapi-jsonpointer-dev
	,golang-github-go-openapi-jsonreference-dev
	,golang-github-elazarl-goproxy-dev
	,golang-github-elazarl-go-bindata-assetfs-dev
	,golang-gopkg-natefinch-lumberjack.v2-dev
	,golang-github-jonboulle-clockwork-dev
	,golang-github-pborman-uuid-dev
	,golang-github-kardianos-osext-dev
	,golang-github-cpuguy83-go-md2man-dev
	,golang-github-mxk-go-flowrate-dev
	,golang-ginkgo-dev
	,golang-gomega-dev
	,golang-github-evanphx-json-patch-dev
	,golang-github-cpuguy83-go-md2man-dev
	,golang-github-mesos-mesos-go-dev
	,golang-github-jmespath-go-jmespath-dev
	,golang-github-xyproto-simpleredis-dev
	,golang-github-jteeuwen-go-bindata-dev
	,golang-github-fsnotify-fsnotify-dev
	,golang-github-stretchr-testify-dev
	,golang-glog-dev
	,golang-github-azure-go-ansiterm-dev
	,golang-github-xiang90-probing-dev
	,golang-github-beorn7-perks-dev
	,golang-github-hawkular-hawkular-client-go-dev
	,golang-github-kr-fs-dev
	,golang-github-kr-pty-dev
	,golang-github-mitchellh-mapstructure-dev
	,golang-github-mitchellh-go-wordwrap-dev
	,golang-gopkg-gcfg.v1-dev
	,golang-github-mvdan-xurls-dev
	,golang-github-puerkitobio-purell-dev
	,golang-go-zfs-dev
	,golang-github-asaskevich-govalidator-dev
	,golang-github-ghodss-yaml-dev
	,golang-github-hashicorp-golang-lru-dev
	,golang-github-hashicorp-hcl-dev
	,golang-golang-x-oauth2-dev
	,golang-golang-x-oauth2-google-dev
	,golang-github-pelletier-go-buffruneio-dev
	,golang-github-pelletier-go-toml-dev
	,golang-github-mailru-easyjson-dev
	,golang-github-vishvananda-netlink-dev
	,golang-github-inconshreveable-mousetrap-dev
	,golang-github-mreiferson-go-httpclient-dev
	,golang-github-howeyc-gopass-dev
	,golang-golang-x-crypto-dev
	,golang-golang-x-sys-dev
	,golang-golang-x-text-dev
	,golang-golang-x-net-dev
	,golang-golang-x-exp-dev
	,golang-github-seccomp-libseccomp-golang-dev
	,golang-github-shurcool-sanitized-anchor-name-dev
	,golang-github-abbot-go-http-auth-dev
	,golang-github-stretchr-objx-dev
	,golang-github-pmezard-go-difflib-dev
	,golang-github-codegangsta-negroni-dev
	,golang-github-samuel-go-zookeeper-dev
	,golang-github-go-ini-ini-dev
	,golang-github-golang-mock-dev
	,golang-github-golang-groupcache-dev
	,golang-github-boltdb-bolt-dev
	,golang-github-russross-blackfriday-dev
	,golang-github-google-gofuzz-dev
	,golang-github-coreos-go-oidc-dev
	,golang-github-magiconair-properties-dev
	,golang-github-sirupsen-logrus-dev
	,golang-github-pkg-errors-dev
	,golang-github-pkg-sftp-dev
	,golang-github-go-openapi-loads-dev
	,golang-github-go-openapi-analysis-dev
	,golang-github-go-openapi-strfmt-dev
	,golang-github-go-openapi-runtime-dev
	,golang-github-go-openapi-errors-dev
	,golang-github-go-openapi-validate-dev
	,golang-github-google-btree-dev
	,golang-github-daviddengcn-go-colortext-dev
	,golang-github-garyburd-redigo-dev
	,golang-github-miekg-dns-dev
	,golang-github-gorilla-context-dev
	,golang-github-gorilla-mux-dev
	,golang-github-lpabon-godbc-dev
	,golang-github-xanzy-go-cloudstack-dev
	,golang-github-makenowjust-heredoc-dev
	,golang-github-docker-spdystream-dev
	,golang-gocapability-dev
	,golang-github-kubernetes-gengo-dev
	,golang-github-robfig-cron-dev
	,golang-github-kubernetes-heapster-dev
	,golang-github-cloudflare-cfssl-dev
	,golang-github-google-certificate-transparency-dev
	,golang-github-vmware-photon-controller-go-sdk-dev
	,golang-github-quobyte-api-dev
	,golang-github-renstrom-dedent-dev
	,golang-github-exponent-io-jsonpath-dev
	,golang-github-docker-go-connections-dev
	,golang-github-docker-go-units-dev
	,golang-github-juju-ratelimit-dev
	,golang-github-ugorji-go-codec-dev
	,golang-github-rackspace-gophercloud-dev
	,golang-protobuf-extensions-dev
	,golang-github-influxdb-influxdb-dev
	,golang-github-coreos-pkg-dev
	,golang-go-semver-dev
	,golang-github-prometheus-client-golang-dev
	,golang-github-prometheus-client-model-dev
	,golang-github-prometheus-common-dev
	,golang-procfs-dev
	,golang-speter-go-exp-math-dec-inf-dev
	,golang-gopkg-yaml.v2-dev
	,golang-github-opennota-urlesc-dev
	,golang-github-vmware-govmomi-dev (>= 0.8.0+git20160719.9.b5ee639~)
	,golang-github-google-cadvisor-dev (>= 0.25.0~)
	,golang-github-imdario-mergo-dev
	,golang-github-docker-engine-api-dev
	,golang-github-coreos-go-systemd-dev
	,golang-github-opencontainers-runc-dev
	,golang-google-cloud-compute-metadata-dev
	,golang-google-appengine-dev
	,golang-github-appc-spec-dev
	,golang-etcd-server-dev
	,golang-github-emicklei-go-restful-dev
	,golang-dbus-dev
	,golang-github-grpc-ecosystem-grpc-gateway-dev
	,golang-github-aws-aws-sdk-go-dev
	,golang-google-api-dev
	,golang-github-skynetservices-skydns-dev
Standards-Version: 3.9.8
Homepage: http://kubernetes.io/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/kubernetes.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/kubernetes.git

Package: kubernetes-client
Provides: kubernetes-utils
Architecture: amd64 i386 armel armhf arm64 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ${misc:Recommends}
Built-Using: ${misc:Built-Using}
Description: Kubernetes client tools
 Kubernetes command line utilities:
  * kubectl -- Kubernetes cluster management utility

Package: kubernetes-master
Architecture: amd64 i386 armel armhf arm64 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
    ,adduser
    ,lsb-base
Recommends: ${misc:Recommends}, kubernetes-client
#            ca-certificates,
#            cgroupfs-mount | cgroup-lite,
Built-Using: ${misc:Built-Using}
Description: Kubernetes services for master host
 Container Cluster Manager from Google. Kubernetes is an open source system
 for managing containerized applications across multiple hosts, providing
 basic mechanisms for deployment, maintenance, and scaling of applications.
 .
 Linux kernel version 3.8 or above is required for proper operation of the
 daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides "kube-apiserver", "kube-controller-manager" and
 "kube-scheduler" daemons.

Package: kubernetes-node
Provides: cadvisor
Architecture: amd64 i386 armel armhf arm64 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
    ,adduser
    ,docker.io
    ,lsb-base
#   ,socat
Recommends: ${misc:Recommends}, kubernetes-client
#            cgroupfs-mount | cgroup-lite,
Built-Using: ${misc:Built-Using}
Description: Kubernetes services for node host
 Container Cluster Manager from Google. Kubernetes is an open source system
 for managing containerized applications across multiple hosts, providing
 basic mechanisms for deployment, maintenance, and scaling of applications.
 .
 Linux kernel version 3.8 or above is required for proper operation of the
 daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides "kube-proxy" and "kubelet" daemons.

#Package: kubernetes-doc
#Section: doc
#Architecture: all
#Depends: ${misc:Depends}
#Description: examples of how to run applications with Kubernetes
# Kubernetes Documentation:
#  * The User's guide is for anyone who wants to run programs and
#    services on an existing Kubernetes cluster.
#  * The "Cluster Admin's guide" is for anyone setting up a Kubernetes
#    cluster or administering it.
#  * The Developer guide describing how to write programs that access the
#    Kubernetes API, write plugins or extensions, or modify the core code of
#    Kubernetes.
#  * The Kubectl Command Line Interface is a detailed reference on the
#    `kubectl` CLI.
#  * The API object documentation is a detailed description of all fields
#    found in core API objects.
#  * An overview of the "Design of Kubernetes".
#  * Example files and walkthroughs.
