=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+)\Z}{.$1},\
 https://github.com/kubernetes/kubernetes/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

#opts=\
#repacksuffix=+dfsg,\
#dversionmangle=s{\+dfsg\d*}{},\
#uversionmangle=s{\-(\d+)\Z}{.$1},\
# https://github.com/kubernetes/kubernetes/releases?after=v1.0.7 \
# .*/archive/v?(\d[\d\.]+)\.tar\.gz
