## kubernetes 1.7.16+dfsg

=== build/root/Makefile ===
--- 
+++ 
@@ -195,7 +195,7 @@
 	@echo "$$TEST_E2E_HELP_INFO"
 else
 test-e2e: ginkgo generated_files
-	go run hack/e2e.go -- -v --build --up --test --down
+	go run hack/e2e.go -- --build --up --test --down
 endif
 
 define TEST_E2E_NODE_HELP_INFO
@@ -351,17 +351,23 @@
 
 define RELEASE_HELP_INFO
 # Build a release
+# Use the 'release-in-a-container' target to build the release when already in
+# a container vs. creating a new container to build in using the 'release'
+# target.  Useful for running in GCB.
 #
 # Example:
 #   make release
-endef
-.PHONY: release
-ifeq ($(PRINT_HELP),y)
-release:
+#   make release-in-a-container
+endef
+.PHONY: release release-in-a-container
+ifeq ($(PRINT_HELP),y)
+release release-in-a-container:
 	@echo "$$RELEASE_HELP_INFO"
 else
 release:
 	build/release.sh
+release-in-a-container:
+	build/release-in-a-container.sh
 endif
 
 define RELEASE_SKIP_TESTS_HELP_INFO
@@ -386,52 +392,40 @@
 	build/release.sh
 endif
 
+define PACKAGE_HELP_INFO
+# Package tarballs
+# Use the 'package-tarballs' target to run the final packaging steps of
+# a release.
+#
+# Example:
+#   make package-tarballs
+endef
+.PHONY: package package-tarballs
+ifeq ($(PRINT_HELP),y)
+package package-tarballs:
+	@echo "$$PACKAGE_HELP_INFO"
+else
+package package-tarballs:
+	build/package-tarballs.sh
+endif
+
 define CROSS_HELP_INFO
 # Cross-compile for all platforms
+# Use the 'cross-in-a-container' target to cross build when already in
+# a container vs. creating a new container to build from (build-image)
+# Useful for running in GCB.
 #
 # Example:
 #   make cross
-endef
-.PHONY: cross
-ifeq ($(PRINT_HELP),y)
-cross:
+#   make cross-in-a-container
+endef
+.PHONY: cross cross-in-a-container
+ifeq ($(PRINT_HELP),y)
+cross cross-in-a-container:
 	@echo "$$CROSS_HELP_INFO"
 else
 cross:
 	hack/make-rules/cross.sh
-endif
-
-define CMD_HELP_INFO
-# Add rules for all directories in cmd/
-#
-# Example:
-#   make kubectl kube-proxy
-endef
-#TODO: make EXCLUDE_TARGET auto-generated when there are other files in cmd/
-#TODO: should we exclude the target "libs" but include "cmd/libs/go2idl/*"?
-EXCLUDE_TARGET=OWNERS
-.PHONY: $(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/))))
-ifeq ($(PRINT_HELP),y)
-$(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/)))):
-	@echo "$$CMD_HELP_INFO"
-else
-$(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/)))): generated_files
-	hack/make-rules/build.sh cmd/$@
-endif
-
-define PLUGIN_CMD_HELP_INFO
-# Add rules for all directories in plugin/cmd/
-#
-# Example:
-#   make kube-scheduler
-endef
-.PHONY: $(notdir $(abspath $(wildcard plugin/cmd/*/)))
-ifeq ($(PRINT_HELP),y)
-$(notdir $(abspath $(wildcard plugin/cmd/*/))):
-	@echo "$$PLUGIN_CMD_HELP_INFO"
-else
-$(notdir $(abspath $(wildcard plugin/cmd/*/))): generated_files
-	hack/make-rules/build.sh plugin/cmd/$@
-endif
-
-define FED_CMD_HELP_INFO
+cross-in-a-container: KUBE_OUTPUT_SUBPATH = $(OUT_DIR)/dockerized
+cross-in-a-container:
+ifeq (,$(wildcard /.dockerenv))
